python early:
    mods = {}
    filters = {}
init 9000 python:
    if  not persistent.filters:
        persistent.filters = []
    for i in sorted(filters.keys()):
        if  not i in [item["id"] for item in persistent.filters]:
            persistent.filters += [{"id":i,"is_active":False}]
    for item in persistent.filters:
        if  item["id"] in filters and item["id"] in renpy.store.__dict__:
            if  item["is_active"]:
                renpy.store.__dict__[item["id"]]()
        else:
            persistent.filters.remove(item)

init python:
    rgsn = renpy.game.script.namemap
    rgsn["_start_original_"],rgsn["start"] = rgsn["start"],rgsn["_start_original_"]

label _start_original_:
    scene backdrop_back
    show backdrop_new
    python:
        ui.button(background=None, clicked=ui.returns("original"), xpos=870, xanchor=0.5, ypos=300)
        ui.text(u"Бесконечное лето 1.1", style="button_text", size=40, hover_color="0f0")
        if len(mods) > 0:
            ui.button(background=None, clicked=ui.returns("mods"), xpos=870, xanchor=0.5, ypos=500)
            ui.text(u"Моды и пользовательские сценарии", style="button_text", size=30, hover_color="0f0")
        if len(filters) > 0:
            ui.button(background=None, clicked=ui.returns("filters"), xpos=870, xanchor=0.5, ypos=550)
            ui.text(u"Управление фильтрами", style="button_text", size=30, hover_color="0f0")
        res = ui.interact()
    if  res == "original":
        jump _start_original_
    elif res == "filters":
        jump filters_selection
    else:
        jump prepare_env

label prepare_env:
    $ renpy.music.stop()
    $ set_mode_adv()
    $ init_map_zones()
    $ make_names_known()
    $ skip_text_blocks = False
    $ font_size="small"
    $ day_time()
    scene bg black
    jump mods_selection

label mods_selection:
    if  len(mods) > 24:
        $ authors = list(set([k.split("__")[0] for k in mods.keys()]))
        $ author = renpy.display_menu(sorted([(k,k) for k in authors]))
        jump expression renpy.display_menu(sorted([(v,k) for (k,v) in mods.iteritems() if k.split("__")[0] == author]))
    else:
        jump expression renpy.display_menu(sorted([("["+k.split("__")[0]+"] "+v,k) for (k,v) in mods.iteritems()]))

label filters_selection:
    scene black
    python:
        def ui_button(text,clicked):
            ui.button(clicked=ui.returns(clicked) if clicked is not None else None, xpos=0, xanchor=0.0, ypos=0, xpadding=6, xminimum=30)
            ui.text(text, style="button_text", size=20)
            
        ui.vbox()
        for i,(item) in enumerate(persistent.filters):
            ui.hbox()
            ui_button("↑",("move_up",i) if i>0 else None)
            ui_button("[x]" if item["is_active"] else "[ ]", ("toggle",i))
            ui_button("↓",("move_down",i) if i<len(filters.keys())-1 else None)
            ui_button("[%s] %s"%(item["id"].split("__")[0],filters[item["id"]]),None)
            ui.close()
        ui_button("Save & restart","done")
        ui_button("Save & apply on next start","exit")
        ui.close()
        result = ui.interact()
    if  isinstance(result,tuple) and result[0] == "toggle":
        $ persistent.filters[result[1]]["is_active"] = not persistent.filters[result[1]]["is_active"]
    if  isinstance(result,tuple) and result[0] == "move_up":
        $ persistent.filters[result[1]-1], persistent.filters[result[1]] = persistent.filters[result[1]], persistent.filters[result[1]-1]
    if  isinstance(result,tuple) and result[0] == "move_down":
        $ persistent.filters[result[1]+1], persistent.filters[result[1]] = persistent.filters[result[1]], persistent.filters[result[1]+1]
    if  result == "done":
        $ renpy.utter_restart()
    if  result == "exit":
        return
    jump filters_selection
